﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;

namespace TestShapeFile
{
    public class CustomStyle : Style
    {
        public CustomStyle()
            : base()
        {

        }
        protected override void DrawCore(IEnumerable<Feature> features, GeoCanvas canvas, Collection<SimpleCandidate> labelsInThisLayer, System.Collections.ObjectModel.Collection<SimpleCandidate> labelsInAllLayers)
        {

            foreach (Feature feature in features)
            {

                try
                {
                    switch (feature.GetWellKnownType())
                    {
                        case WellKnownType.Line:
                        case WellKnownType.Multiline:
                            try
                            {
                                GeoPen geoPen = new GeoPen(GeoColor.StandardColors.Red);

                                if (feature.GetShape() is LineShape)
                                {
                                    LineShape line = feature.GetShape() as LineShape;
                                    HandleLine180Crossing(canvas, line);
                                    canvas.DrawLine(line, geoPen, DrawingLevel.LevelOne);
                                }
                                else if (feature.GetShape() is MultilineShape)
                                {
                                    MultilineShape multiline = feature.GetShape() as MultilineShape;
                                    foreach (LineShape line in multiline.Lines)
                                    {
                                        HandleLine180Crossing(canvas, line);
                                        canvas.DrawLine(line, geoPen, DrawingLevel.LevelOne);
                                    }
                                }

                            }
                            catch
                            {
                            }
                            break;

                    }
                }
                catch (Exception ex)
                {

                }

            }

        }

        private static void HandleLine180Crossing(GeoCanvas canvas, LineShape line)
        {
            for (int i = 1; i < line.Vertices.Count; i++)
            {
                if (line.Vertices[i].X - line.Vertices[i - 1].X > 20031163.131814)
                { line.Vertices[i] = new Vertex(line.Vertices[i].X - 40067780.91867692, line.Vertices[i].Y); }
                else if (line.Vertices[i - 1].X - line.Vertices[i].X > 20031163.131814)
                { line.Vertices[i] = new Vertex(line.Vertices[i].X + 40067780.91867692, line.Vertices[i].Y); }
            }
            if (!canvas.CurrentWorldExtent.Intersects(line))
            {
                line.TranslateByOffset(-360, 0, GeographyUnit.Meter, DistanceUnit.Meter);
            }
        }

    }
}
